let data;

function preload() {
  data = loadTable('https://gist.githubusercontent.com/hollyjpotter/45952a6c5373b5c8b69fdd272dc0fccc/raw/142b61919367aea37ecfa79b8b370667f7d42c53/powerData.csv', 'csv', 'header');
}

function setup() {
  createCanvas(1000,1000);
  
  text('Boxplot of CO2 Levels in European Countries', 380, 280);
  
  text('Carbon Intensity (gCO2/kWh) 2020', 400, 450);
  
  var nrows = data.getRowCount();

  var intensity = [];
  var place = 0;
  
  for (i = 0; i < nrows; i++) {
      intensity[place] = parseInt(data.getRow(i).getString("2020"));
      place++;
  }
  
  //Sort values
  intensity.sort(function(a, b) {
    return a - b;
  });
    
  //median value
  const medianVal = (arr, len) => {
    const mid = Math.floor(arr.length/2);
    
    if (arr.length%2 != 0){
      return (arr[mid-1]+arr[mid])/2;
    }
    
    else {
      return (arr[mid]);
    }
  }
    
  var half = Math.ceil(intensity.length / 2);
  
  //min value
  var minval = min(intensity);
  
  //Quartile1
  var q1 = medianVal(intensity.slice(0, half), half);
    
  //Median
  var q2 = medianVal(intensity, intensity.length);
  
  //Quartile3
  var q3 = medianVal(intensity.slice(half, intensity.length),
        intensity.slice(half, intensity.length).length);
  
  //max value
  var maxval = max(intensity);

  var x = 275;
  var y = 405;
  var dx = 0;
  
  for (let i = 0; i < 9; i++) {
    text("|", x + dx, y);
    text((i * 100), x + dx, y + 15);
    dx += 60;
  }
  

  rect(minval + 275, minval + 333, 0, 30);
  line(minval + 275, 360, 385, 360);
  rect(q1+280, 375, (q2 - q1) - 80, -30);
  rect(398, 375, (q3-q2)/2, -30);
  line(448, 360, 723, 360);
  rect(maxval, 350, 0, 30);
  
}